//+------------------------------------------------------------------+
//|                                     CLOSE PRICE CROSSES OVER EMA |
//|                                                     Duarte Silva |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+

/*-------------------------------------------------------------------
Alguns comentrios ao EA:
- Necessrio como tratar ordens pendentes pois so eliminadas na inexistncia de conformidade de EMAs;
- Melhorar risco R:R;
- Equacionar a possibilidade de adicionarmos um indicador adicional: estocstico;
- Such signaling fractals remain valid till a pending entry order is triggered or a new valid fractal is formed;
- Efetuar apenas uma ordem no mercado de cada vez; - Validar cdigo implementado
- implementar o trailing stop
- using Fibonacci levels when no such neighboring cluster exists, while using a risk/reward ratio of 1:2 or 1:3 when setting stop losses allows
- Utilizar fractais com TF weekly
--------------------------------------------------------------------*/


#property copyright "Duarte Silva"
#property strict
#property link "http://forex-indicators.net/bill-williams/fractals"  //Visto
#property link "http://blackglasses.me/2014/05/11/fractals-and-forex-a-new-perspective/" //Visto
#property link "http://www.investopedia.com/articles/trading/06/fractals.asp" //Visto
#property link "https://www.mql5.com/en/articles/1201"//Visto
#property link "https://www.mql5.com/en/code/8718"
#property link "https://www.mql5.com/en/articles/1429"


#define FractalStudy "EA for Fractal study"

//+------------------------------------------------------------------+
//| Indicadores                                                      |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//--- Buffer dos indicadores
double Fractal_Upper_Buffer[];
double Fractal_Lower_Buffer[];

//+------------------------------------------------------------------+
//| Declarao e inicializao de Variveis Externas (Optimizao)   |
//+------------------------------------------------------------------+
extern int EMA_sPeriod = 5;
extern int EMA_lPeriod = 24;
extern int EMA_vlPeriod = 45;
extern int ADX_Period = 14;
extern int Fractal_Method = 1;
//+------------------------------------------------------------------+
//| Declarao das Variveis Globais da funo                       |
//+------------------------------------------------------------------+
bool LongTrend,ShortTrend,LongOnMarket,ShortOnMarket,FractalUpperFound,FractalLowerFound;
int ticket=0,PositionIndex=0,NumSellOrders=0,NumBuyOrders=0;
double OrderPrice=0.0;
double Lots, PriceMargin = 0.0030, PriceValue, SLMargin = 0.0030, StopLossValue, TakeProfitValue;
double ShortEMA, ShortEMA_P, LongEMA, LongEMA_P,VLongEMA, VLongEMA_P;
double ADXValue, ADXPlusDI, ADXMinusDI;
double Fractal_Upper,Fractal_Lower;
double LastHighUpFractal, PreviousHighUpFractal, LastMinLowFractal, PreviousMinLowFractal;
datetime Lastbar,Curbar; //Open time of last bar   // Open time of current bar
int iMagicNum=19820506;
int Previous_Bars=0,Unchecked_Bars=0, Control_Bars = 0;
string DeleteObjectName;
int ObjTotal,FractalUpperCounter=0,FractalLowerCounter=0,UpperBarIndex=0,LowerBarIndex=0;
//+------------------------------------------------------------------+
//| Inicializao do Expert Adviser                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- Data/hora de abertura da ltima barra
   Lastbar=Time[1];

   Previous_Bars=Bars;////////////////////////////////////////////Ateno ao nmero de barras do histrico)
   Unchecked_Bars=0;
   Print("*** INICIALIZAO ***");
   Print("N de barras a ler: ",Previous_Bars);

//--- Gerar um  nmero nico para cada par
   if(Symbol()=="EURUSD") iMagicNum=iMagicNum+1+Period();
   else if(Symbol() == "USDJPY") iMagicNum= iMagicNum + 2 + Period();
   else if(Symbol() == "GBPUSD") iMagicNum= iMagicNum + 3 + Period();
   else Print("Nenhum Simbolo Seleccionado");

   Print("Simbolo: ",Symbol(),"Nmero Mgico: ",iMagicNum);

//---- indicator buffers mapping
   SetIndexBuffer(0,Fractal_Upper_Buffer);
   SetIndexBuffer(1,Fractal_Lower_Buffer);
//---- drawing settings
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,119);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(0,119);
//---- Name for Datawindow
   SetIndexLabel(0,"Fractal Up");
   SetIndexLabel(0,"Fractal Down");
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {

//--- Variveis locais e estticas
   if(NewBarDetection()) //Aes a realizar no incio de cada vela japonesa
     {
      //Indicador Alligator
      //ShortEMA = iMA(NULL,0,EMA_sPeriod,0,MODE_EMA,PRICE_CLOSE,1);
      LongEMA = iMA(NULL,0,EMA_lPeriod,0,MODE_EMA,PRICE_CLOSE,1);
      //VLongEMA = iMA(NULL,0,EMA_vlPeriod,0,MODE_EMA,PRICE_CLOSE,1);
      
      //ShortEMA_P = iMA(NULL,0,EMA_sPeriod,0,MODE_EMA,PRICE_CLOSE,2);
      LongEMA_P = iMA(NULL,0,EMA_lPeriod,0,MODE_EMA,PRICE_CLOSE,2);
      //VLongEMA_P = iMA(NULL,0,EMA_vlPeriod,0,MODE_EMA,PRICE_CLOSE,2);
      
      //Indicador ADX
      /*ADXValue = iADX(NULL,0, ADX_Period,0, MODE_MAIN, 1);
      ADXPlusDI = iADX(NULL,0, ADX_Period,0, MODE_PLUSDI, 1);
      ADXMinusDI = iADX(NULL,0, ADX_Period,0, MODE_MINUSDI, 1);*/
      
      
      //----------------- CONFIRMAO DE FRACTAIS------------------------------------------
      if((FractalLowerFound) && (Bars>=LowerBarIndex + 2))
        {
         Control_Bars = Bars - LowerBarIndex;
         if(Low[Control_Bars] < Low[Control_Bars+2] && Low[Control_Bars] < Low[Control_Bars+1] && Low[Control_Bars] < Low[Control_Bars-1] && Low[Control_Bars] < Low[Control_Bars-2])
           {
            FractalLowerCounter = FractalLowerCounter - 1;
            FractalLowerFound = false;
            Print("Contador de Lower Fractals: ", FractalLowerCounter);
            Print("Lower Fractal CONFIRMADO: ",iTime(NULL,0,Control_Bars));
            
            //GestaoDeBreakouts();
            PreviousMinLowFractal = LastMinLowFractal;
            LastMinLowFractal = Low[Control_Bars];
            Print("LastMinLowFractal: ", LastMinLowFractal, " PreviousMinLowFractal: ",PreviousMinLowFractal, " LongEMA_P: ", LongEMA_P, " LongEMA: ",LongEMA);
            
             if (Fractal_Method == 1)
               {
                if((CountOrders("OP_SELLSTOP") == 1 && Close[Control_Bars] < LongEMA) || (CountOrders("OP_SELL") == 1)) //--------------------- Alterao das ordens dadas
                  {
                  PriceValue = LastMinLowFractal - PriceMargin;
                  StopLossValue = LastHighUpFractal + SLMargin;// - (LastHighUpFractal - LastMinLowFractal)/2
                  TakeProfitValue = PriceValue - 2 * (StopLossValue - PriceValue);                  
                  if (CountOrders("OP_SELLSTOP") == 1) ModifyOrders("OP_SELLSTOP");
                  if (CountOrders("OP_SELL") == 1) ModifyOrders("OP_SELL");
                  }
                
               if (CountOrders("OP_BUY") ==1)
                  {
                  StopLossValue = LastMinLowFractal;
                  ModifyOrders("OP_BUY");
                  }                    
                
                //if((LastMinLowFractal < LongEMA)//Regras indicadas pelo Bill Williams: If a Sell fractal is below the Alligator's teeth traders should place a pending Sell Stop order few points below the low of the sell fractal.
                if((LastMinLowFractal != 0) && (LastHighUpFractal != 0)                //--------------------- Confirmao de novo fractal -> Nova Ordem
                  && (CountOrders("OP_SELLSTOP") == 0) /*&& (CountOrders("OP_SELL") == 0)*/ && Close[Control_Bars] < LongEMA)
                  {
                  PriceValue = LastMinLowFractal - PriceMargin;
                  StopLossValue = LastHighUpFractal + SLMargin;// - (LastHighUpFractal - LastMinLowFractal)/2
                  TakeProfitValue = PriceValue - 2 * (StopLossValue - PriceValue);
                  SellOnStopPosition(0.1);
                  }
                } 
              }
         else
           {
            FractalLowerCounter = FractalLowerCounter - 1;
            FractalLowerFound = false;
            ObjTotal=ObjectsTotal() -2;
            DeleteObjectName = "ARROW BUY Obj: "+TimeToString(iTime(NULL,0,Control_Bars));
            DeleteObject(DeleteObjectName);
            Print("Contador de Lower Fractals: ", FractalLowerCounter, "N de Objectos", ObjTotal);
            Print("Lower Fractal FALSO -> APAGAR: ",iTime(NULL,0,Control_Bars), " -> ",DeleteObjectName);
           }
        }
      if((FractalUpperFound) && (Bars>=UpperBarIndex + 2))
        {
            Control_Bars = Bars - UpperBarIndex;
            if(High[Control_Bars] > High[Control_Bars+2] && High[Control_Bars] >= High[Control_Bars+1] && High[Control_Bars] >= High[Control_Bars-1] && High[Control_Bars] > High[Control_Bars-2])
              {
               FractalUpperCounter = FractalUpperCounter - 1;
               FractalUpperFound = false;
               //Print("Contador de Upper Fractals: ", FractalUpperCounter);
               Print("Upper Fractal CONFIRMADO: ",iTime(NULL,0,Control_Bars));
               
               //GestaoDeBreakouts();
               PreviousHighUpFractal = LastHighUpFractal;
               LastHighUpFractal = High[Control_Bars];
               Print("LastHighUpFractal: ", LastHighUpFractal, " PreviousHighUpFractal: ",PreviousHighUpFractal, " LongEMA_P: ", LongEMA_P, " LongEMA: ",LongEMA);
               
               if (Fractal_Method == 1)
                  {
                  if((CountOrders("OP_BUYSTOP") == 1 && Close [Control_Bars] > LongEMA) || (CountOrders("OP_BUY") == 1)) //--------------------- Alterao das ordens dadas
                     {
                     PriceValue = LastHighUpFractal + PriceMargin;
                     StopLossValue = LastMinLowFractal - SLMargin;// + (LastHighUpFractal - LastMinLowFractal)/2
                     TakeProfitValue = PriceValue + 2 * (PriceValue - StopLossValue);
                     if (CountOrders("OP_BUYSTOP") == 1) ModifyOrders("OP_BUYSTOP");
                     if (CountOrders("OP_BUY") == 1) ModifyOrders("OP_BUY");
                     }
                     
                  if (CountOrders("OP_SELL") ==1)
                     {
                     StopLossValue = LastHighUpFractal;
                     ModifyOrders("OP_SELL");
                     }                    
                  
                  
                  if((LastMinLowFractal != 0) && (LastHighUpFractal != 0)              //--------------------- Confirmao de novo fractal -> Nova Ordem
                     && (CountOrders("OP_BUYSTOP") == 0) /*&& (CountOrders("OP_BUY") == 0)*/ && Close [Control_Bars] > LongEMA)
                    {
                     PriceValue = LastHighUpFractal + PriceMargin;
                     StopLossValue = LastMinLowFractal - SLMargin;// + (LastHighUpFractal - LastMinLowFractal)/2
                     TakeProfitValue = PriceValue + 2 * (PriceValue - StopLossValue);                  
                     BuyOnStopPosition(0.1);
                     }
                  }    
              }
             else
               {
               FractalUpperCounter = FractalUpperCounter - 1;
               FractalUpperFound = false;
               ObjTotal=ObjectsTotal() -2;
               DeleteObjectName = "ARROW SELL Obj: "+TimeToString(iTime(NULL,0,Control_Bars));
               DeleteObject(DeleteObjectName);
               //Print("Contador de Upper Fractals: ", FractalUpperCounter, "N de Objectos", ObjTotal);
               Print("Upper Fractal FALSO -> APAGAR: ",iTime(NULL,0,Control_Bars), " -> ",DeleteObjectName);
               }
        }
        
      //---------------------- DETEO DE FRACTAIS ------------------------------  
      if(Bars<0) Print("Erro na contagem de barras");
      
      Unchecked_Bars= Bars-Previous_Bars;
      Previous_Bars = Bars;
      Print("N de barras a ler: ",Unchecked_Bars," N de barras total: ",Bars);

      for(int i=1; i<Unchecked_Bars+2;i++)
        {
         Fractal_Lower=iFractals(NULL,0,MODE_LOWER,i);
         if(Fractal_Lower!=NULL)
           {
            FractalLowerCounter=FractalLowerCounter+1;
            FractalLowerFound=true;
            LowerBarIndex=Bars - i;
            Print("Lower Fractal: ",NormalizeDouble(Fractal_Lower,3)," Contador de Lower Fractals: ",FractalLowerCounter," Fractal Index: ", LowerBarIndex);
            if(!ObjectCreate("ARROW BUY Obj: "+TimeToString(Time[i],TIME_DATE|TIME_SECONDS),OBJ_ARROW_UP,0,Time[i],Low[i]))
              {
               Print("Erro impresso objecto - Lower: ",GetLastError());
              }
           }
         Fractal_Upper=iFractals(NULL,0,MODE_UPPER,i);
         if(Fractal_Upper!=NULL)
           {
            FractalUpperCounter=FractalUpperCounter+1;
            FractalUpperFound=true;
            UpperBarIndex=Bars - i;
            Print("Upper Fractal: ",NormalizeDouble(Fractal_Upper,3),"Contador de Upper Fractals: ",FractalUpperCounter," Fractal Index: ",UpperBarIndex);
            if(!ObjectCreate("ARROW SELL Obj: "+TimeToString(Time[i],TIME_DATE|TIME_SECONDS),OBJ_ARROW_DOWN,0,Time[i],High[i]+0.003))
              {
               Print("Erro impresso objecto - Upper: ",GetLastError());
              }
           }
        }
      /*if (CountOpenOrders() >=1)
         {
         ClosePendingOrders();
         }                    

      //-------- Elimina ordens quando as mdias no esto ordenadas
      if((ShortEMA > LongEMA && ShortEMA > VLongEMA) || (ShortEMA > LongEMA && ShortEMA > VLongEMA))
        {
         Print("EMAs ordenadas");
        }
      else
        {
         Print("EMAs desordenadas - Eliminar ordens pendentes");
         //CloseOpenOrders();
         ClosePendingOrders();
        }*/  
      

     }   //NewBarDetection
  }
//+------------------------------------------------------------------+
//| Funes Auxiliares                                            |
//+------------------------------------------------------------------+

//--------------------- Detecta abertura de nova barra --------------------------//
bool NewBarDetection()
  {
   Curbar=Time[0]; // Open time of current bar

   if(Lastbar!=Curbar)
     {
      Lastbar=Curbar;
      Print("Nova Barra: ", TimeToString(Time[0],TIME_DATE|TIME_SECONDS));
      //FractalUpperFound = false;
      //FractalLowerFound = false;

      NumBuyOrders=0;
      NumSellOrders=0;   //Inicializar os contadores

      for(PositionIndex=OrdersTotal()-1; PositionIndex>=0; PositionIndex--)
        {
         if(OrderSelect(PositionIndex,SELECT_BY_POS) && OrderMagicNumber()==iMagicNum && OrderSymbol()==Symbol())
           {
            if(OrderType() == OP_BUY)  NumBuyOrders++;
            if(OrderType() == OP_SELL) NumSellOrders++;
           }
        }
      //Print("Buy Orders: ",NumBuyOrders,"Sell Orders: ",NumSellOrders);

      return (true);
     }
   else return(false);

  }
//--------------------- Apaga Objectos --------------------------//
void DeleteObject(string sname)
   {
   for(int iObj=ObjectsTotal()-1; iObj >= 0; iObj--)
      {
       string on = ObjectName(iObj);
       if (StringFind(on,sname) == 0)
         {
         ObjectDelete(on);
         Print("OBJECTO APAGADO: ", on);
         }
       }   
   }  
//--------------------- Efetua a compra de posies longas --------------------------//
void BuyOnStopPosition(double lots)
  {
   Print("Dados para compra Buy On Stop: PriceValue = ",PriceValue, " SLoss = ",StopLossValue, " TProfit = ", TakeProfitValue);
   ticket = OrderSend(Symbol(),OP_BUYSTOP,lots,PriceValue,3,StopLossValue,TakeProfitValue,"Compra Longos",iMagicNum,0,Blue);
   if(ticket<0)
     {
      Print("Ordem Falhada por Erro:# ",GetLastError());
     }
   else
     {
      Print("Ordem Buy On Stop bem sucedida: ticket = ",ticket);
     }
  }
//--------------------- Efetua a compra de posies curtas --------------------------//
void SellOnStopPosition(double lots)
  {
   Print("Dados para compra Sell On Stop: PriceValue = ",PriceValue, " SLoss = ",StopLossValue, " TProfit = ", TakeProfitValue);
   ticket = OrderSend(Symbol(),OP_SELLSTOP,lots,PriceValue,3,StopLossValue,TakeProfitValue,"Compra Curtos",iMagicNum,0,Red);
   if(ticket<0)
     {
      Print("Ordem Falhada por Erro:# ",GetLastError());
     }
   else
     {
      Print("Ordem Sell On Stop bem Sucedida: ticket =",ticket);
     }
  }
//--------------------- Fechar ordens abertas --------------------------//
bool CloseOpenOrders()
  {
   Print("N de ordens totais:# ",OrdersTotal());

   for(PositionIndex=OrdersTotal()-1; PositionIndex>=0; PositionIndex --) //  <-- for loop to loop through all Orders . .   COUNT DOWN TO ZERO !
     {
      if(!OrderSelect(PositionIndex,SELECT_BY_POS,MODE_TRADES)) continue;   // <-- if the OrderSelect fails advance the loop to the next PositionIndex

      if(!OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3))
        {
         Print("Ordem Falhada por Erro:# ",OrderTicket()," Error: ",GetLastError());  // <-- if the Order Close failed print some helpful information 
         return (false);
        }
      else
        {
         Print("Ordem fechada correctamente ");
         if(LongOnMarket==1) LongOnMarket=0;
         if(ShortOnMarket==1) ShortOnMarket=0;
         return (true);
        }
     }
   return(0);
  }
//--------------------- Fechar ordens pendentes --------------------------//
bool ClosePendingOrders()  // <-- https://forum.mql4.com/48352
  {
   Print("N de ordens totais:# ",OrdersTotal());

   for(PositionIndex = OrdersTotal()-1; PositionIndex >= 0; PositionIndex --) //  <-- for loop to loop through all Orders . .   COUNT DOWN TO ZERO !
     {
      if(!OrderSelect(PositionIndex,SELECT_BY_POS,MODE_TRADES)) continue;   // <-- if the OrderSelect fails advance the loop to the next PositionIndex

      if( OrderMagicNumber() == iMagicNum && OrderSymbol() == Symbol()         //<-- does the Order's Magic Number match our EA's magic number ? <-- does the Order's Symbol match the Symbol our EA is working on ? 
      && ( OrderType() == OP_SELLLIMIT          
      ||   OrderType() == OP_BUYSTOP
      ||   OrderType() == OP_BUYLIMIT
      ||   OrderType() == OP_SELLSTOP))      // <-- or is it a Sell Order ?
   
      if ( ! OrderDelete(OrderTicket(),clrGreen)) // <-- try to delete the order
        {
         Print("Ordem Falhada por Erro:# ",OrderTicket()," Error: ",GetLastError());  // <-- if the Order Close failed print some helpful information 
         return (false);
        }
      else
        {
         Print("Ordem fechada correctamente ");
         //if(LongOnMarket==1) LongOnMarket=0;
         //if(ShortOnMarket==1) ShortOnMarket=0;
         return (true);
        }
     }
   return(0);
  }
 
//--------------------- Contagem de ordens abertas --------------------------//
int CountOpenOrders()  // <-- https://forum.mql4.com/48352
  {
   Print("N de ordens totais:# ",OrdersTotal());
   int CountOrders = 0;
   
   for(PositionIndex = OrdersTotal()-1; PositionIndex >= 0; PositionIndex --) //  <-- for loop to loop through all Orders . .   COUNT DOWN TO ZERO !
     {
      if(!OrderSelect(PositionIndex,SELECT_BY_POS,MODE_TRADES)) continue;   // <-- if the OrderSelect fails advance the loop to the next PositionIndex
         {
         if( OrderMagicNumber() == iMagicNum && OrderSymbol() == Symbol() && (OrderType() == OP_BUY || OrderType() == OP_SELL))
            {
            CountOrders = CountOrders + 1;
            }
         }
     }
   return(CountOrders);
   Print("N de ordens abertas:# ",CountOrders);

  }
  //--------------------- Contagem de ordens pendentes --------------------------//
int CountOrders(string TypeOrder)
  {
   Print("Contador de ordens por tipo de ordem. N de ordens totais: ",OrdersTotal());
   int CountBuyPendingOrders = 0,CountSellPendingOrders = 0, CountBuyOpenOrders = 0, CountSellOpenOrders = 0;
   
   for(PositionIndex = OrdersTotal()-1; PositionIndex >= 0; PositionIndex --) //  <-- for loop to loop through all Orders . .   COUNT DOWN TO ZERO !
     {
      if(!OrderSelect(PositionIndex,SELECT_BY_POS,MODE_TRADES)) continue;   // <-- if the OrderSelect fails advance the loop to the next PositionIndex
         {
         if( OrderMagicNumber() == iMagicNum && OrderSymbol() == Symbol() && (OrderType() == OP_BUYSTOP))
            {
            CountBuyPendingOrders = CountBuyPendingOrders + 1;
            }
         if( OrderMagicNumber() == iMagicNum && OrderSymbol() == Symbol() && (OrderType() == OP_SELLSTOP))
            {
            CountSellPendingOrders = CountSellPendingOrders + 1;
            }
         if( OrderMagicNumber() == iMagicNum && OrderSymbol() == Symbol() && (OrderType() == OP_BUY))
            {
            CountBuyOpenOrders = CountBuyOpenOrders + 1;
            }
         if( OrderMagicNumber() == iMagicNum && OrderSymbol() == Symbol() && (OrderType() == OP_SELL))
            {
            CountSellOpenOrders = CountSellOpenOrders + 1;
            }         
         }
     }
   if(TypeOrder == "OP_BUYSTOP") return(CountBuyPendingOrders);
   else if(TypeOrder == "OP_SELLSTOP") return(CountSellPendingOrders);
   else if(TypeOrder == "OP_BUY") return(CountBuyOpenOrders);
   else if(TypeOrder == "OP_SELL") return(CountSellOpenOrders);
   else return -1;
   Print("N de ordens BuyOpen: ",CountBuyOpenOrders," e SellOpen: ", CountSellOpenOrders, " SellOnStop: ",CountBuyPendingOrders, " e SellOnStop: ", CountSellPendingOrders);

  }
  //--------------------- Modificao de Ordens --------------------------//
void ModifyOrders(string sTypeOrder)
  {
   int CountOrders = 0, IndexSave = 0, OrderTypeNum = 0;
   //Converte o tipo de ordem   
   if(sTypeOrder == "OP_BUY") OrderTypeNum = 0;
   else if(sTypeOrder == "OP_SELL") OrderTypeNum = 1;
   else if(sTypeOrder == "OP_BUYLIMIT") OrderTypeNum = 2;
   else if(sTypeOrder == "OP_SELLLIMIT")  OrderTypeNum = 3;  
   else if(sTypeOrder == "OP_BUYSTOP") OrderTypeNum = 4;
   else if(sTypeOrder == "OP_SELLSTOP")  OrderTypeNum = 5;  
   else OrderTypeNum = -1;
   
   Print("*** Funo Modificao de ordens ***: Order Number = ", OrderTypeNum, " TypeOrder: ", sTypeOrder);
    
   for(PositionIndex = OrdersTotal()-1; PositionIndex >= 0; PositionIndex --) //  <-- for loop to loop through all Orders . .   COUNT DOWN TO ZERO !
     {
      if(!OrderSelect(PositionIndex,SELECT_BY_POS,MODE_TRADES)) continue;   // <-- if the OrderSelect fails advance the loop to the next PositionIndex
         {
         if(OrderMagicNumber() == iMagicNum && OrderSymbol() == Symbol() && OrderType() == OrderTypeNum)
            {
            Print("Ordem seleccionada do tipo pretendido. Ticket: ", OrderTicket(), " Tipo:", OrderType(), " Price:", OrderOpenPrice(), " SL:", OrderStopLoss(), " TP:", OrderTakeProfit());
            if (sTypeOrder == "OP_BUY" || sTypeOrder == "OP_SELL")   // No caso das ordens abertas apenas alteramos o stop loss vindo do main
               {
               PriceValue = OrderClosePrice();
               TakeProfitValue = OrderTakeProfit();
               }
            
            Print("Dados para modificao de ordens: Price: ", PriceValue, " SL: ", StopLossValue, " TP: ", TakeProfitValue);
            if(OrderModify(ticket,PriceValue,StopLossValue,TakeProfitValue,0,Green))
              {
               Print("Ordem de modificao bem sucedida.");
              }
            else Print("Erro: Ordem de modificao mal executada!!",GetLastError());
            
            CountOrders = CountOrders + 1;
            Print("Posio do ndice de ordens: ", PositionIndex, "; N de ordens do mesmo tipo: ", CountOrders);
            }
         }
     }
  }
//--------------------- Trailing Stop Orders --------------------------//
void TrailingStopOrder ()
   {
   Print("*** Funo Trailing Stop Order ***");
   if(OrderSelect(ticket,SELECT_BY_TICKET)==true)
      {
      Print("Ordem seleccionada - Ticket Correto");
      if (OrderType() == OP_BUY) TakeProfitValue = OrderClosePrice() + ((OrderClosePrice() - StopLossValue)*2);
      if (OrderType() == OP_SELL) TakeProfitValue = OrderClosePrice() - ((StopLossValue - OrderClosePrice())*2);
      PriceValue = OrderClosePrice();
      TakeProfitValue = OrderTakeProfit();
      Print("Dados para modificao de ordens: Price: ", PriceValue, " SL: ", StopLossValue, " TP: ", TakeProfitValue);
      if(OrderModify(ticket,PriceValue,StopLossValue,TakeProfitValue,0,Green))
        {
         Print("Ordem de modificao bem sucedida:Trailing Stop Ajustado");
        }
      else Print("Erro: Ordem de modificao mal executada!!");
      }
   else Print("Ordem mal seleccionada - Ticket Incorreto");
   }
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
